unit NMath;

interface

function ArcSin(X: Double): Double;
function ArcTan2(Y, X: Double): Double;
function FMod(A, B: Double): Double;
function Floor(X: Double): Double;
function Pow(B, E: Double): Double;
function Tan(X: Double): Double;

implementation

function ArcSin(X: Double): Double;
asm
  // Result := ArcTan2(X, Sqrt(1-X*X));
  fld X  // 0:X
  fld X  // 0:X, 1:X
  fmul st(0), st(1)  // 0:X*X, 1:X
  fld1   // 0:1, 1:X*X, 2:X
  fsubrp // 0:1-X*X, 1:X
  fsqrt  // 0:Sqrt(1-X*X), 1:X
  fpatan
  fwait
end;

function ArcTan2(Y, X: Double): Double;
asm
  fld Y
  fld X
  fpatan
  fwait
end;

function FMod(A, B: Double): Double;
begin
  Result := A - Floor(A / B) * B;
end;

function Floor(X: Double): Double;
var
  savecw, workcw: Word;
asm
  fld X
  fnstcw savecw
  fnstcw workcw
  fwait
  and workcw, $f3ff
  or workcw, $0400
  fldcw workcw
  frndint
  fwait
  fldcw savecw
end;

function Pow(B, E: Double): Double;
begin
  Result := Exp(E * Ln(B));
end;

function Tan(X: Double): Double;
asm
  fld X
  fptan
  fstp st(0)
  fwait
end;

end.
